// Package concerto_metamodel_1_0_0 contains domain objects and was generated from Concerto namespace concerto.metamodel@1.0.0.
package concerto_metamodel_1_0_0
import "concerto_1_0_0";
   
type Position struct {
   concerto_1_0_0.Concept
   Line int32 `json:"line"`
   Column int32 `json:"column"`
   Offset int32 `json:"offset"`
}
type Range struct {
   concerto_1_0_0.Concept
   Start Position `json:"start"`
   End Position `json:"end"`
   Source string `json:"source"`
}
type TypeIdentifier struct {
   concerto_1_0_0.Concept
   Name string `json:"name"`
   Namespace string `json:"namespace"`
}
type DecoratorLiteral struct {
   concerto_1_0_0.Concept
   Location Range `json:"location"`
}
type DecoratorString struct {
   DecoratorLiteral
   Value string `json:"value"`
}
type DecoratorNumber struct {
   DecoratorLiteral
   Value float64 `json:"value"`
}
type DecoratorBoolean struct {
   DecoratorLiteral
   Value bool `json:"value"`
}
type DecoratorTypeReference struct {
   DecoratorLiteral
   Type TypeIdentifier `json:"type"`
   IsArray bool `json:"isArray"`
}
type Decorator struct {
   concerto_1_0_0.Concept
   Name string `json:"name"`
   Arguments []DecoratorLiteral `json:"arguments"`
   Location Range `json:"location"`
}
type Identified struct {
   concerto_1_0_0.Concept
}
type IdentifiedBy struct {
   Identified
   Name string `json:"name"`
}
type Declaration struct {
   concerto_1_0_0.Concept
   Name string `json:"name"`
   Decorators []Decorator `json:"decorators"`
   Location Range `json:"location"`
}
type MapDeclaration struct {
   Declaration
   Key MapKeyType `json:"key"`
   Value AggregateValueType `json:"value"`
}
type MapKeyType struct {
   concerto_1_0_0.Concept
   Type TypeIdentifier `json:"type"`
   Decorators []Decorator `json:"decorators"`
   Location Range `json:"location"`
}
type AggregateValueType struct {
   concerto_1_0_0.Concept
   Type TypeIdentifier `json:"type"`
   Decorators []Decorator `json:"decorators"`
   Location Range `json:"location"`
}
type AggregateRelationshipValueType struct {
   AggregateValueType
}
type EnumDeclaration struct {
   Declaration
   Properties []EnumProperty `json:"properties"`
}
type EnumProperty struct {
   concerto_1_0_0.Concept
   Name string `json:"name"`
   Decorators []Decorator `json:"decorators"`
   Location Range `json:"location"`
}
type ConceptDeclaration struct {
   Declaration
   IsAbstract bool `json:"isAbstract"`
   Identified Identified `json:"identified"`
   SuperType TypeIdentifier `json:"superType"`
   Properties []Property `json:"properties"`
}
type AssetDeclaration struct {
   ConceptDeclaration
}
type ParticipantDeclaration struct {
   ConceptDeclaration
}
type TransactionDeclaration struct {
   ConceptDeclaration
}
type EventDeclaration struct {
   ConceptDeclaration
}
type Property struct {
   concerto_1_0_0.Concept
   Name string `json:"name"`
   IsArray bool `json:"isArray"`
   IsOptional bool `json:"isOptional"`
   Decorators []Decorator `json:"decorators"`
   Location Range `json:"location"`
}
type RelationshipProperty struct {
   Property
   Type TypeIdentifier `json:"type"`
}
type ObjectProperty struct {
   Property
   DefaultValue string `json:"defaultValue"`
   Type TypeIdentifier `json:"type"`
}
type BooleanProperty struct {
   Property
   DefaultValue bool `json:"defaultValue"`
}
type DateTimeProperty struct {
   Property
}
type StringProperty struct {
   Property
   DefaultValue string `json:"defaultValue"`
   Validator StringRegexValidator `json:"validator"`
   LengthValidator StringLengthValidator `json:"lengthValidator"`
}
type StringRegexValidator struct {
   concerto_1_0_0.Concept
   Pattern string `json:"pattern"`
   Flags string `json:"flags"`
}
type StringLengthValidator struct {
   concerto_1_0_0.Concept
   MinLength int32 `json:"minLength"`
   MaxLength int32 `json:"maxLength"`
}
type DoubleProperty struct {
   Property
   DefaultValue float64 `json:"defaultValue"`
   Validator DoubleDomainValidator `json:"validator"`
}
type DoubleDomainValidator struct {
   concerto_1_0_0.Concept
   Lower float64 `json:"lower"`
   Upper float64 `json:"upper"`
}
type IntegerProperty struct {
   Property
   DefaultValue int32 `json:"defaultValue"`
   Validator IntegerDomainValidator `json:"validator"`
}
type IntegerDomainValidator struct {
   concerto_1_0_0.Concept
   Lower int32 `json:"lower"`
   Upper int32 `json:"upper"`
}
type LongProperty struct {
   Property
   DefaultValue int64 `json:"defaultValue"`
   Validator LongDomainValidator `json:"validator"`
}
type LongDomainValidator struct {
   concerto_1_0_0.Concept
   Lower int64 `json:"lower"`
   Upper int64 `json:"upper"`
}
type Import struct {
   concerto_1_0_0.Concept
   Namespace string `json:"namespace"`
   Uri string `json:"uri"`
}
type ImportAll struct {
   Import
}
type ImportType struct {
   Import
   Name string `json:"name"`
}
type ImportTypes struct {
   Import
   Types []string `json:"types"`
}
type Model struct {
   concerto_1_0_0.Concept
   Namespace string `json:"namespace"`
   SourceUri string `json:"sourceUri"`
   ConcertoVersion string `json:"concertoVersion"`
   Imports []Import `json:"imports"`
   Declarations []Declaration `json:"declarations"`
   Decorators []Decorator `json:"decorators"`
}
type Models struct {
   concerto_1_0_0.Concept
   Models []Model `json:"models"`
}
type ScalarDeclaration struct {
   Declaration
}
type BooleanScalar struct {
   ScalarDeclaration
   DefaultValue bool `json:"defaultValue"`
}
type IntegerScalar struct {
   ScalarDeclaration
   DefaultValue int32 `json:"defaultValue"`
   Validator IntegerDomainValidator `json:"validator"`
}
type LongScalar struct {
   ScalarDeclaration
   DefaultValue int64 `json:"defaultValue"`
   Validator LongDomainValidator `json:"validator"`
}
type DoubleScalar struct {
   ScalarDeclaration
   DefaultValue float64 `json:"defaultValue"`
   Validator DoubleDomainValidator `json:"validator"`
}
type StringScalar struct {
   ScalarDeclaration
   DefaultValue string `json:"defaultValue"`
   Validator StringRegexValidator `json:"validator"`
   LengthValidator StringLengthValidator `json:"lengthValidator"`
}
type DateTimeScalar struct {
   ScalarDeclaration
   DefaultValue string `json:"defaultValue"`
}
